#[derive(
    Debug,
    Clone,
    conjure_object::serde::Serialize,
    conjure_object::serde::Deserialize,
    PartialEq,
    Eq,
    PartialOrd,
    Ord,
    Hash
)]
#[serde(crate = "conjure_object::serde")]
#[conjure_object::private::staged_builder::staged_builder]
#[builder(crate = conjure_object::private::staged_builder, update, inline)]
pub struct ChannelMetadata {
    #[builder(custom(type = super::ChannelIdentifier, convert = Box::new))]
    #[serde(rename = "channelIdentifier")]
    channel_identifier: Box<super::ChannelIdentifier>,
    #[builder(default, into)]
    #[serde(rename = "description", skip_serializing_if = "Option::is_none", default)]
    description: Option<String>,
    #[builder(default, into)]
    #[serde(rename = "unit", skip_serializing_if = "Option::is_none", default)]
    unit: Option<String>,
    #[builder(default, into)]
    #[serde(rename = "dataType", skip_serializing_if = "Option::is_none", default)]
    data_type: Option<super::super::super::super::api::SeriesDataType>,
}
impl ChannelMetadata {
    /// Constructs a new instance of the type.
    #[inline]
    pub fn new(channel_identifier: super::ChannelIdentifier) -> Self {
        Self::builder().channel_identifier(channel_identifier).build()
    }
    #[inline]
    pub fn channel_identifier(&self) -> &super::ChannelIdentifier {
        &*self.channel_identifier
    }
    #[inline]
    pub fn description(&self) -> Option<&str> {
        self.description.as_ref().map(|o| &**o)
    }
    #[inline]
    pub fn unit(&self) -> Option<&str> {
        self.unit.as_ref().map(|o| &**o)
    }
    #[inline]
    pub fn data_type(&self) -> Option<&super::super::super::super::api::SeriesDataType> {
        self.data_type.as_ref().map(|o| &*o)
    }
}
